<template>
  <div class="consenso-detalle">
    <template v-if="consenso">
      <div class="title">
        <h1>{{ consenso.titulo }}</h1>
        <button class="circle" @click="refrescar" :class="{ loading }">
          <LoadingIcono />
        </button>
      </div>
      <p v-if="barca && !barca.abordada">
        de la barca
        <router-link class="link-barca" :to="`/barcas/${barcaId}`">
          {{ barca.nombre }}</router-link
        >.
        <router-link :to="`/barcas/${barcaId}/abordar`">
          abordar esta barca
        </router-link>
      </p>
      <div class="texto">
        <Markdown :markdown="consenso.texto" />
      </div>
      <barra-de-estado :posiciones="consenso.posiciones" />
      <p>
        {{ date.getDate() }}/{{ date.getMonth() }}/{{ date.getFullYear() }} |
        {{ date.getHours() }}:{{ date.getMinutes() }}hs
      </p>
      <router-link
        v-if="consenso.posiciones.length < 1"
        tag="button"
        :to="`/barcas/${barcaId}/consensos/${id}/eliminar`"
      >
        Eliminar propuesta
      </router-link>
      <posiciones :posiciones="consenso.posiciones" />
      <tomar-posicion-form
        v-if="barca && barca.abordada"
        :consensoId="consenso.id"
        :barcaId="barcaId"
        :posicionPrevia="posicionPrevia"
      />
      <p v-else>
        no podés tomar posición en un consenso de una barca que no abordaste.
      </p>
    </template>
    <h1 v-else-if="loading">Cargando...</h1>
    <div v-else-if="error">
      <h1>Error: {{ error }}</h1>
      <custom-button @click="refrescar" :loading="loading">
        Reintentar
      </custom-button>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex'

import CustomButton from '@/components/Button.vue'
import BarraDeEstado from '@/components/BarraDeEstado.vue'
import Posiciones from '@/components/Posiciones.vue'
import TomarPosicionForm from '@/components/TomarPosicionForm.vue'
import Markdown from '@/components/Markdown.vue'
import LoadingIcono from '@/assets/iconos/loading.svg?inline'

export default {
  name: 'ConsensoView',
  components: {
    CustomButton,
    BarraDeEstado,
    Posiciones,
    TomarPosicionForm,
    Markdown,
    LoadingIcono,
  },
  data() {
    return {
      error: null,
      loading: true,
    }
  },
  computed: {
    id() {
      return parseInt(this.$route.params.id)
    },
    barcaId() {
      return parseInt(this.$route.params.barcaId)
    },
    barca() {
      return this.barcas.find(barca => barca.id == this.barcaId)
    },
    consenso() {
      return this.consensos.find(consenso => consenso.id == this.id)
    },
    date() {
      return new Date(this.consenso.created_at)
    },
    ...mapState(['barcas', 'consensos']),
    ...mapState({
      posicionPrevia(state) {
        if (this.consenso) {
          return [...this.consenso.posiciones]
            .reverse()
            .find(posicion => posicion.pirata.id === state.profile.id)
        }
      },
    }),
  },
  methods: {
    refrescar() {
      this.error = null
      this.loading = true
      return Promise.all([
        this.$store.dispatch('conseguirBarca', { barcaId: this.barcaId }),
        this.$store.dispatch('conseguirConsenso', {
          consensoId: this.id,
          barcaId: this.barcaId,
        }),
      ])
        .catch(error => (this.error = error))
        .finally(() => (this.loading = false))
    },
  },
  mounted() {
    this.refrescar()
  },
}
</script>

<style lang="sass" scoped>
.consenso-detalle
  margin: 0 10px
.texto
  border-left: 5px solid var(--gray)
  padding-left: .5em
.title
  width: 100%
  margin-top: 1em
  h1
    display: inline
    margin: 0
    margin-right: .2em
.link-barca
  color: var(--foreground)
</style>
